/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "PPKMouseAddon.h"
#include "ApplicationUtility.h"

VOID PPKMOUSEADDON_API vSetDdrawflagProxied(VOID){
	try{
		reinterpret_cast<VOID (__stdcall *)(VOID)>(GetProcAddress(dllReal, "vSetDdrawflag"))();
	}catch(unsigned int errCode){
		ApplicationUtility::getInstance().showTypeSafeErrorMessage(errCode, L"Proxification - vSetDdrawflagProxied");
	}
}

BOOL PPKMOUSEADDON_API AlphaBlendProxied(HDC p1, int p2, int p3, int p4, int p5, HDC p6, int p7, int p8, int p9, int p10, BLENDFUNCTION p11){
	try{
		return reinterpret_cast<BOOL (__stdcall *)(HDC, int, int, int, int, HDC, int, int, int, int, BLENDFUNCTION)>(GetProcAddress(dllReal, "AlphaBlend"))(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11);
	}catch(unsigned int errCode){
		ApplicationUtility::getInstance().showTypeSafeErrorMessage(errCode, L"Proxification - AlphaBlendProxied");
	}
	return FALSE;
}

BOOL PPKMOUSEADDON_API TransparentBltProxied(HDC p1, int p2, int p3, int p4, int p5, HDC p6, int p7, int p8, int p9, int p10, UINT p11){
	try{
		return reinterpret_cast<BOOL (__stdcall *)(HDC, int, int, int, int, HDC, int, int, int, int, UINT)>(GetProcAddress(dllReal, "TransparentBlt"))(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11);
	}catch(unsigned int errCode){
		ApplicationUtility::getInstance().showTypeSafeErrorMessage(errCode, L"Proxification - TransparentBltProxied");
	}
	return FALSE;
}

BOOL PPKMOUSEADDON_API GradientFillProxied(HDC p1, PTRIVERTEX p2, ULONG p3, PVOID p4, ULONG p5, ULONG p6){
	try{
		return reinterpret_cast<BOOL (__stdcall *)(HDC, PTRIVERTEX, ULONG, PVOID, ULONG, ULONG)>(GetProcAddress(dllReal, "GradientFill"))(p1, p2, p3, p4, p5, p6);
	}catch(unsigned int errCode){
		ApplicationUtility::getInstance().showTypeSafeErrorMessage(errCode, L"Proxification - GradientFillProxied");
	}
	return FALSE;	
}